# TeamSwap release 1 by Steven Hartin
# ./addons/eventscripts/teamswap/teamswap.py

# >>> To configure this addon please see teamswap.cfg <<<

import es, math, playerlib, gamethread, os.path

info = es.AddonInfo()
info.name = 'TeamSwap'
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/teamswap'
info.basename = 'teamswap'
info.author = 'Freddukes AKA Pro Noob'

players = {}
oldstats = {}

dict_options = {'bot_multiplier':[2.0,'The amount of bots per humans.'],'bot_diff':[2,'How hard the bots are for the teamswap time'],'human_team':['T','Which team the humans will join.'],'percent_of_votes_required':[60,'The percentage of the Total Players required to vote to accept the Team Change.'],'advert_delay':[120,'Time in seconds to delay the TeamSwap advert']}

def load():
    global votes, voteoccured, oldstats, players
    for a in dict_options:
        es.ServerVar(a,dict_options[a][0],dict_options[a][1])
        
    if os.path.isfile(es.getAddonPath('teamswap') + '/teamswap.cfg'):
        es.server.cmd('es_xmexec ../addons/eventscripts/teamswap/teamswap.cfg')
    else:
        es.dbgmsg(0, 'TeamSwap: Unable to load teamswap.cfg! Please ensure it is in the ./teamswap/ directory.')
        
    teamswap_version = es.ServerVar('teamswap_version',info.version,'Current Version of TeamSwap - by Freddukes').makepublic()
        
    votes, voteoccured = 0,0
    gamethread.delayed(5,setOldStats)
    for a in playerlib.getUseridList('#human'):
        players[a] = 0
    gamethread.delayedname(int(es.ServerVar('advert_delay')),'advert',advert)
    
def setOldStats():
    global oldstats
    bq = str(es.ServerVar('bot_quota'))
    bjt = str(es.ServerVar('bot_join_team'))
    ht = str(es.ServerVar('mp_humanteam'))
    lt = str(es.ServerVar('mp_limitteam'))
    bqm = str(es.ServerVar('bot_quota_mode'))
    bav = str(es.ServerVar('bot_auto_vacate'))
    bd = str(es.ServerVar('bot_difficulty'))
    oldstats = {'bq':bq,'bjt':bjt,'ht':ht,'lt':lt,'bqm':bqm,'bav':bav,'bd':bd}
    
def unload():
    es.server.queuecmd('bot_kick')
    gamethread.delayed(1,reset_values)
    gamethread.cancelDelayed('advert')
    
def advert():
    if not voteoccured:
        es.msg('#multi','#green[TeamSwap] #lightgreenis on. Type #green\'voteswap\'#lightgreento vote for Bots vs Humans!')
    gamethread.delayedname(int(es.ServerVar('advert_delay')),'advert',advert)

def player_activate(ev):
    if ev['es_steamid'] != "BOT":
        global players
        if voteoccured:
            a = math.floor(int(es.ServerVar('bot_multiplier')))
            new_bot_quota = es.ServerVar('bot_quota') + a
            es.server.queuecmd('bot_quota %s'%new_bot_quota)
        players[ev['userid']] = 0
    
def player_disconnect(ev):
    if ev['es_steamid'] != "BOT":
        global players
        if players[ev['userid']]:
            global votes
            votes -= 1
        if voteoccured:
            a = math.floor(int(es.ServerVar('bot_multiplier')))
            new_bot_quota = es.ServerVar('bot_quota') - a
            es.server.queuecmd('bot_quota %s'%new_bot_quota)
        del players[ev['userid']]

def player_team(ev):
    if voteoccured:
        if es.getplayersteamid(ev['userid']) != "BOT":
            if ev['team'] == '1':
                a = math.floor(int(es.ServerVar('bot_multiplier')))
                new_bot_quota = es.ServerVar('bot_quota') - a
                es.server.queuecmd('bot_quota %s'%new_bot_quota)
            elif ev['team'] in '23':
                a = math.floor(int(es.ServerVar('bot_multiplier')))
                new_bot_quota = es.ServerVar('bot_quota') + a
                es.server.queuecmd('bot_quota %s'%new_bot_quota)

def player_say(ev):
    if ev['text'] == 'voteswap':
        if not voteoccured:
            global players
            if not players[ev['userid']]:
                global votes
                players[ev['userid']] = 1
                votes += 1
                votecount = 0
                for a in playerlib.getUseridList('#human'):
                    votecount += 1
                if votes >= float(votecount) * int(es.ServerVar('percent_of_votes_required')) / 100:
                    global voteoccured
                    voteoccured = 1
                    es.server.queuecmd('bot_kick')
                    es.server.queuecmd('es_forcevalue bot_difficulty %s'%str(es.ServerVar('bot_diff')))
                    es.server.queuecmd('es_forcevalue mp_limitteams 0')
                    es.server.queuecmd('es_forcevalue mp_humanteam %s'%es.ServerVar('human_team'))
                    es.server.queuecmd('es_forcevalue bot_quota_mode normal')
                    es.server.queuecmd('es_forcevalue bot_auto_vacate 0')
                    human_team = str(es.ServerVar('human_team'))
                    if human_team.lower() == 't':
                        es.server.queuecmd('es_forcevalue bot_join_team CT')
                        for a in playerlib.getUseridList('#human,#ct'):
                            es.changeteam(a,2)
                    else:
                        es.server.queuecmd('es_forcevalue bot_join_team T')
                        for a in playerlib.getUseridList('#human,#t'):
                            es.changeteam(a,3)
                    es.server.queuecmd('es_forcevalue bot_quota %s'%(round(votecount * int(es.ServerVar('bot_multiplier')))))
                    gamethread.delayed(2,es.msg,('#green','Teams have been swapped. They will be un-swapped at map change.'))
                else:
                    votes_needed = float(votecount) * int(es.ServerVar('percent_of_votes_required')) / 100 - votes
                    a = math.floor(votes_needed) + 1
                    es.msg('#green','Player %s has voted to swap the teams. %.0f more votes required.'%(ev['es_username'],a))
            else:
                es.tell(ev['userid'],'#green','Sorry you can only vote once.')
        else:
            es.tell(ev['userid'],'#green','Team swapping has already occured.')

def es_map_start(event_var):
    global votes, voteoccured
    votes, voteoccured = 0,0
    es.server.queuecmd('bot_kick')
    gamethread.delayed(5,reset_values)
    players.clear()

def reset_values():
    global oldstats
    es.server.queuecmd('es_forcevalue bot_difficulty %s'%oldstats['bd'])
    es.server.queuecmd('es_forcevalue bot_join_team %s'%oldstats['bjt'])
    es.server.queuecmd('es_forcevalue mp_humanteam %s'%oldstats['ht'])
    es.server.queuecmd('es_forcevalue mp_limitteams %s'%oldstats['lt'])
    es.server.queuecmd('es_forcevalue bot_quota_mode %s'%oldstats['bqm'])
    es.server.queuecmd('es_forcevalue bot_auto_vacate %s'%oldstats['bav'])
    es.server.queuecmd('es_forcevalue bot_quota %s'%oldstats['bq'])
